import * as METADATA from '@loafer/pouches/constants';

import {
  Construtorable,
  DecoratorType,
} from '@loafer/core/constants';

import {
  PouchScope,
  DEFAULT_QUALIFIER,
} from '@loafer/pouches/constants';

import PouchFactory from '@loafer/pouches/factory/PouchFactory';
import PouchDefinition from '@loafer/pouches/factory/config/PouchDefinition';
import PouchDefinitionRegistry from '@loafer/pouches/factory/registry/PouchDefinitionRegistry';

class DefaultPouchFactory implements PouchFactory, PouchDefinitionRegistry {
  public constructor() {
  }

  public getPouch<T>(type: Construtorable<T>, ...args: any[]): T {
    let qualifier = DEFAULT_QUALIFIER;
    return this.getPouchByQualifier(type, qualifier, args);
  }

  public getPouchByQualifier<T>(type: Construtorable<T>, qualifier: string | symbol, ...args: any[]): T {
    let clazz: Function = type.prototype;
    let instance: T;
    return instance;
  }

  public registerPouchDefinition(pouchDefinition: PouchDefinition): void {
    let type = pouchDefinition.Type;
    let qualifier = pouchDefinition.Qualifier;

  }
  public removePouchDefinition(type: Object, qualifier?: string | symbol): void {

  }
  public getPouchDefinition(type: Object, qualifier?: string | symbol): PouchDefinition {

  }
  public hasPouchDefinition(type: Object, qualifier?: string | symbol): boolean {

  }
  public getPouchDefinitions(): PouchDefinition[] {

  }
  public getPouchDefinitionCount(): number {

  }

}

export default DefaultPouchFactory;
